<?php
// File called by class?
if ( isset( $this ) == false || get_class( $this ) != 'plugin_delete_me' ) exit;

// Does user have the capability for this menu page?
if ( current_user_can( 'delete_users' ) == false ) return; // stop executing file

// Form nonce
$form_nonce_action = $this->GET['page'] . '_nonce_action';
$form_nonce_name = $this->GET['page'] . '_nonce_name';

// Save changes
if ( isset( $this->POST[$form_nonce_name] ) && wp_verify_nonce( $this->POST[$form_nonce_name], $form_nonce_action ) == true ) {
	
	// Roles	
	settype( $this->POST['roles'], 'array' );
	
	foreach ( $this->wp_roles->role_objects as $role ) {
		
		$checked = ( isset( $this->POST['roles'][$role->name] ) ) ? true : false;
		$has_cap = ( $role->has_cap( $this->info['cap'] ) ) ? true : false;
		
		if ( $checked == true && $has_cap == false ) {
			
			$role->add_cap( $this->info['cap'] );
			
		} elseif ( $checked == false && $has_cap == true ) {
			
			$role->remove_cap( $this->info['cap'] );
			
		}
		
	}
	
	$default_option = $this->default_option();
	
	// Users -> Your Profile	
	settype( $this->POST['your_profile_class'], 'string' );
	settype( $this->POST['your_profile_style'], 'string' );
	settype( $this->POST['your_profile_anchor'], 'string' );
	settype( $this->POST['your_profile_js_confirm'], 'string' );
	settype( $this->POST['your_profile_landing_url'], 'string' );
	settype( $this->POST['your_profile_enabled'], 'bool' );
	$this->option['settings']['your_profile_class'] = ( empty( $this->POST['your_profile_class'] ) ) ? NULL : $this->POST['your_profile_class'];
	$this->option['settings']['your_profile_style'] = ( empty( $this->POST['your_profile_style'] ) ) ? NULL : $this->POST['your_profile_style'];
	$this->option['settings']['your_profile_anchor'] = ( empty( $this->POST['your_profile_anchor'] ) ) ? $default_option['settings']['your_profile_anchor'] : $this->POST['your_profile_anchor'];
	$this->option['settings']['your_profile_js_confirm'] = ( empty( $this->POST['your_profile_js_confirm'] ) ) ? $default_option['settings']['your_profile_js_confirm'] : $this->POST['your_profile_js_confirm'];
	$this->option['settings']['your_profile_landing_url'] = ( empty( $this->POST['your_profile_landing_url'] ) ) ? $default_option['settings']['your_profile_landing_url'] : $this->POST['your_profile_landing_url'];
	$this->option['settings']['your_profile_enabled'] = $this->POST['your_profile_enabled'];
	
	// Shortcode	
	settype( $this->POST['shortcode_class'], 'string' );
	settype( $this->POST['shortcode_style'], 'string' );
	settype( $this->POST['shortcode_anchor'], 'string' );
	settype( $this->POST['shortcode_js_confirm'], 'string' );
	settype( $this->POST['shortcode_landing_url'], 'string' );
	$this->option['settings']['shortcode_class'] = ( empty( $this->POST['shortcode_class'] ) ) ? NULL : $this->POST['shortcode_class'];
	$this->option['settings']['shortcode_style'] = ( empty( $this->POST['shortcode_style'] ) ) ? NULL : $this->POST['shortcode_style'];
	$this->option['settings']['shortcode_anchor'] = ( empty( $this->POST['shortcode_anchor'] ) ) ? $default_option['settings']['shortcode_anchor'] : $this->POST['shortcode_anchor'];
	$this->option['settings']['shortcode_js_confirm'] = ( empty( $this->POST['shortcode_js_confirm'] ) ) ? $default_option['settings']['shortcode_js_confirm'] : $this->POST['shortcode_js_confirm'];
	$this->option['settings']['shortcode_landing_url'] = ( empty( $this->POST['shortcode_landing_url'] ) ) ? $default_option['settings']['shortcode_landing_url'] : $this->POST['shortcode_landing_url'];
	
	// Multisite: Delete from Network	
	settype( $this->POST['ms_delete_from_network'], 'bool' );
	$this->option['settings']['ms_delete_from_network'] = $this->POST['ms_delete_from_network'];
	
	// Delete Comments	
	settype( $this->POST['delete_comments'], 'bool' );
	$this->option['settings']['delete_comments'] = $this->POST['delete_comments'];
	
	// E-mail notification	
	settype( $this->POST['email_notification'], 'bool' );
	$this->option['settings']['email_notification'] = $this->POST['email_notification'];
	
	// Uninstall on deactivate	
	settype( $this->POST['uninstall_on_deactivate'], 'bool' );
	$this->option['settings']['uninstall_on_deactivate'] = $this->POST['uninstall_on_deactivate'];
	
	// Save Option	
	$this->save_option();
	
	// Print admin message	
	$this->admin_message_class = 'updated';
	$this->admin_message_content = '<strong>Settings saved.</strong>';
	$this->admin_message();
	
}
?>
<div class="wrap">
	<div class="icon32" id="icon-options-general"><br/></div>
	<h2><?php echo $this->info['name']; ?> Settings</h2>
	<form action="options-general.php?page=<?php echo $this->GET['page']; ?>" method="post">
		<h3>Roles</h3>
		<table class="form-table">
			<tr>
				<th scope="row">Which roles can delete themselves?</th>
				<td>
				<?php
				
				foreach ( $this->wp_roles->role_objects as $role ) {
					
					$disabled = ( $role->name == 'administrator' ) ? ' disabled="disabled"' : '';						
					
					?>
					
					<label>
						<input type="checkbox" name="roles[<?php echo $role->name; ?>]" value="1"<?php echo ( $role->has_cap( $this->info['cap'] ) == true ) ? ' checked="checked"' : ''; echo $disabled; ?> />
						<?php if ( $role->name == 'administrator' ) { echo esc_html( 'Super Admin & ' ); } echo esc_html( $this->wp_roles->roles[$role->name]['name'] ); ?>
					</label>
					<br />
					
					<?php
					
				}
				
				?>
				<br />
				<div>
					<span class="description">
						Super Admins &amp; Administrators are disabled because they can already delete users in WordPress, no need to complicate that.
						For testing purposes you'll want to use a separate WordPress login with a role other than Super Admin &amp; Administrator so the delete links you configure are visible to you.
					</span>
				</div>
				</td>
			</tr>
		</table>
		<h3>Users &rarr; Your Profile</h3>
		<table class="form-table">
			<tr>
				<th scope="row"><label for="your_profile_anchor">Link</label> <a href="#" onclick="return false;" style="text-decoration: none;" title="Class &amp; Style are optional. The last box is the clickable content of the link in raw HTML (e.g. Delete Profile &mdash; or &mdash; &lt;img alt=&quot;&quot; src=&quot;http://www.example.com/image.png&quot; width=&quot;100&quot; height=&quot;20&quot; /&gt;)">[?]</a></th>
				<td>
					<code>
						&lt;a
						class="<input type="text" name="your_profile_class" class="code" value="<?php echo esc_attr( $this->option['settings']['your_profile_class'] ); ?>" />"
						style="<input type="text" name="your_profile_style" class="code" value="<?php echo esc_attr( $this->option['settings']['your_profile_style'] ); ?>" />"
						&gt;
						<input type="text" id="your_profile_anchor" name="your_profile_anchor" class="code" value="<?php echo esc_attr( $this->option['settings']['your_profile_anchor'] ); ?>" />
						&lt;/a&gt;
					</code>
				</td>
			</tr>
			<tr>
				<th scope="row"><label for="your_profile_js_confirm">Javascript Confirm</label> <a href="#" onclick="return false;" style="text-decoration: none;" title="Text used for Javascript confirm dialog box. Use \n for new lines and %username% for Username.">[?]</a></th>
				<td>
					<input type="text" id="your_profile_js_confirm" name="your_profile_js_confirm" class="code large-text" value="<?php echo esc_attr( $this->option['settings']['your_profile_js_confirm'] ); ?>" />
				</td>
			</tr>
			<tr>
				<th scope="row"><label for="your_profile_landing_url">Landing URL</label> <a href="#" onclick="return false;" style="text-decoration: none;" title="Redirect user here after deletion.">[?]</a></th>
				<td>
					<input type="text" id="your_profile_landing_url" name="your_profile_landing_url" class="code large-text" value="<?php echo esc_url( $this->option['settings']['your_profile_landing_url'] ); ?>" />
				</td>
			</tr>
			<tr>
				<th scope="row"><label for="your_profile_enabled">Enabled</label> <a href="#" onclick="return false;" style="text-decoration: none;" title="Check box to show delete link, uncheck box to hide delete link.">[?]</a></th>
				<td>
					<input type="checkbox" id="your_profile_enabled" name="your_profile_enabled" value="1"<?php echo ( $this->option['settings']['your_profile_enabled'] == true ) ? ' checked="checked"' : ''; ?> />
				</td>
			</tr>
		</table>
		<h3>Shortcode</h3>
		<table class="form-table">
			<tr>
				<th scope="row"><label for="shortcode_anchor">Link</label> <a href="#" onclick="return false;" style="text-decoration: none;" title="Class &amp; Style are optional. The last box is the clickable content of the link in raw HTML (e.g. Delete Profile &mdash; or &mdash; &lt;img alt=&quot;&quot; src=&quot;http://www.example.com/image.png&quot; width=&quot;100&quot; height=&quot;20&quot; /&gt;)">[?]</a></th>
				<td>
					<code>
						&lt;a
						class="<input type="text" name="shortcode_class" class="code" value="<?php echo esc_attr( $this->option['settings']['shortcode_class'] ); ?>" />"
						style="<input type="text" name="shortcode_style" class="code" value="<?php echo esc_attr( $this->option['settings']['shortcode_style'] ); ?>" />"
						&gt;
						<input type="text" id="shortcode_anchor" name="shortcode_anchor" class="code" value="<?php echo esc_attr( $this->option['settings']['shortcode_anchor'] ); ?>" />
						&lt;/a&gt;
					</code>
				</td>
			</tr>
			<tr>
				<th scope="row"><label for="shortcode_js_confirm">Javascript Confirm</label> <a href="#" onclick="return false;" style="text-decoration: none;" title="Text used for Javascript confirm dialog box. Use \n for new lines and %username% for Username.">[?]</a></th>
				<td>
					<input type="text" id="shortcode_js_confirm" name="shortcode_js_confirm" class="code large-text" value="<?php echo esc_attr( $this->option['settings']['shortcode_js_confirm'] ); ?>" />
				</td>
			</tr>
			<tr>
				<th scope="row"><label for="shortcode_landing_url">Landing URL</label> <a href="#" onclick="return false;" style="text-decoration: none;" title="Redirect user here after deletion.">[?]</a></th>
				<td>
					<input type="text" id="shortcode_landing_url" name="shortcode_landing_url" class="code large-text" value="<?php echo esc_url( $this->option['settings']['shortcode_landing_url'] ); ?>" />
				</td>
			</tr>
			<tr>
				<th scope="row">Usage <a href="#" onclick="return false;" style="text-decoration: none;" title="Text inside the Shortcode open and close tags is only served to those who cannot delete themselves, everyone else will be shown the delete link configured above.">[?]</a></th>
				<td>
					<p>
						<code>[<?php echo $this->info['shortcode']; ?> /]</code><br />
						<code>[<?php echo $this->info['shortcode']; ?>]Text inside Shortcode tags[/<?php echo $this->info['shortcode']; ?>]</code>
					</p>
					<p>
						<code>&lt;?php echo do_shortcode( '[<?php echo $this->info['shortcode']; ?> /]' ); ?&gt;</code><br />
						<code>&lt;?php echo do_shortcode( '[<?php echo $this->info['shortcode']; ?>]Text inside Shortcode tags[/<?php echo $this->info['shortcode']; ?>]' ); ?&gt;</code>
					</p>
				</td>
			</tr>
		</table>
		<h3>Multisite <span class="description">( <?php echo ( is_multisite() ) ? 'On' : 'Off - The setting below applies only to WordPress Multisite installations.'; ?> )</span></h3>
		<table class="form-table">
			<tr>
				<th scope="row"><label for="ms_delete_from_network">Delete From Network</label> <a href="#" onclick="return false;" style="text-decoration: none;" title="When a user deletes themselves from this Site, IF THEY DON'T BELONG TO ANY OTHER NETWORK SITES their user will be deleted permanently from the Network.">[?]</a></th>
				<td>
					<input type="checkbox" id="ms_delete_from_network" name="ms_delete_from_network" value="1"<?php echo ( $this->option['settings']['ms_delete_from_network'] == true ) ? ' checked="checked"' : ''; ?> />
				</td>
			</tr>
		</table>
		<h3>Miscellaneous</h3>
		<table class="form-table">
			<tr>
				<th scope="row"><label for="delete_comments">Delete Comments</label> <a href="#" onclick="return false;" style="text-decoration: none;" title="Delete all comments by the user when they delete themselves. IF MULTISITE only comments on the current Site are deleted, other Network Sites remain unaffected.">[?]</a></th>
				<td>
					<input type="checkbox" id="delete_comments" name="delete_comments" value="1"<?php echo ( $this->option['settings']['delete_comments'] == true ) ? ' checked="checked"' : ''; ?> />
				</td>
			</tr>
			<tr>
				<th scope="row"><label for="email_notification">E-mail Notification</label> <a href="#" onclick="return false;" style="text-decoration: none;" title="Send a text email with deletion details each time a user deletes themselves using <?php echo $this->info['name']; ?>. This will go to the site administrator email (i.e. <?php echo get_option( 'admin_email' ); ?>), the same email address used for new user notification.">[?]</a></th>
				<td>
					<input type="checkbox" id="email_notification" name="email_notification" value="1"<?php echo ( $this->option['settings']['email_notification'] == true ) ? ' checked="checked"' : ''; ?> />
				</td>
			</tr>
			<tr>
				<th scope="row"><label for="uninstall_on_deactivate">Uninstall on Deactivate</label> <a href="#" onclick="return false;" style="text-decoration: none;" title="Remove all settings and capabilities created by this plugin on &quot;Deactivate&quot;.">[?]</a></th>
				<td>
					<input type="checkbox" id="uninstall_on_deactivate" name="uninstall_on_deactivate" value="1"<?php echo ( $this->option['settings']['uninstall_on_deactivate'] == true ) ? ' checked="checked"' : ''; ?> />
				</td>
			</tr>
		</table>
		<p class="submit">
			<?php wp_nonce_field( $form_nonce_action, $form_nonce_name ); ?>
			<input type="submit" class="button-primary" value="Save Changes" />
		</p>
	</form>
</div>
